/***************************************************************************
                          number.cpp  -  description
                             -------------------
    begin                : Wed Mar 1 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "number.h"
#include "defs.h"

Number::Number(SDL_Surface *scr, SDLSurface *bkgnd, SDLFont *fnt, int px, int py, int *val, float pms)
	   : screen(scr), backgnd(bkgnd), font(fnt), x(px), y(py), dest_val(val), cur_val(*val), per_msec(pms),
	     active(1)
{
	sprintf(string, " ");
	dx = dy = dw = dh = 0;
}

Number::~Number()
{
}

void Number::Update(int ms /*time since last call*/)
{
	if (!active || *dest_val == (int)cur_val || ms == 0) return;
	float change = (float)ms * per_msec;
	int old = (int)cur_val;
	int dir = 1; if (cur_val > *dest_val) dir = -1;
	cur_val += change * (float)dir;
	if (old == (int)cur_val) return;
	if ((dir == 1 && cur_val > *dest_val) || (dir == -1 && cur_val < *dest_val))
		cur_val = *dest_val;
}

void Number::Refresh()
{
    if (!active) return;
	SDL_UpdateRect(screen, dx, dy, dw, dh);
}

void Number::Show(SDL_Rect *rects, int *rect_num)
{
    if (!active) return;
	sprintf(string, "%i", (int)cur_val);
	font->Write(screen, x, y, string, TEXT_TRP);
	dx = font->LastX();
	dy = font->LastY();
	dw = font->LastW();
	dh = font->LastH();
	if (*rect_num < DRAWRECTS) {
		SDL_Rect	rect = {dx, dy, dw, dh};
		rects[(*rect_num)++] = rect;
	}
}

void Number::SetPtr(int *ptr)
{
	dest_val = ptr;
}

void Number::Hide(SDL_Rect *rects, int *rect_num)
{
    if (!active) return;
	backgnd->Blit(dx, dy, screen, dx, dy, dw, dh);
	if (*rect_num < DRAWRECTS) {
		SDL_Rect	rect = {dx, dy, dw, dh};
		rects[(*rect_num)++] = rect;
	}
}

void Number::Reset()
{
	cur_val = *dest_val;
}

void Number::Move(int px, int py)
{
    if (!active) return;
    x = px; y = py;
}

void Number::SetActive(int a)
{
    active = a;
}
