/***************************************************************************
                          number.h  -  description
                             -------------------
    begin                : Wed Mar 1 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NUMBER_H
#define NUMBER_H


/**
  *@author Michael Speck
  */

#include "sdl.h"
#include <sys/timeb.h>

class Number {
public: 
	Number(SDL_Surface *scr, SDLSurface *bkgnd, SDLFont *fnt, int px, int py, int *val, float per_msec);
	~Number();
	void Update(int ms);
	void Refresh();
	void Show(SDL_Rect *rects, int *rect_num);
	void Hide(SDL_Rect *rects, int *rect_num);
	void SetPtr(int *ptr);
	void Reset();
	void Move(int px, int py);
	void SetActive(int a);
private:
	SDL_Surface	*screen;
	SDLSurface	*backgnd;
	SDLFont		*font;
	int			x;
	int			y;
	int			*dest_val;
	float		cur_val;
	float		per_msec;
	char		string[32];
	int			dx;
	int			dy;
	int			dw;
	int			dh;
	int         active;
};

#endif
