/***************************************************************************
                          preview.cpp  -  description
                             -------------------
    begin                : Sat Apr 15 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "preview.h"
#include "bowl.h"
#include "defs.h"

Preview::Preview(int px, int py, int pw, int ph, SDL *sdl, SDLSurface *bkgnd, SDLSurface *blocks, Bowl *b, int t)
    : x(px), y(py), w(pw), h(ph), backgnd(bkgnd), bowl(b), q_mark(0), q_pct(0), is_unknown(0), trp(t)
{
    //sdl
    Preview::sdl = sdl;

    //block gfx
    Preview::blocks = blocks;

    //block pic
    block = new SDLSurface(w, h, SDL_SWSURFACE);
    backgnd->Blit(0, 0, block, 0, 0, w, h);

    //frame
	SD_CBx(backgnd->Surface()->pixels, backgnd->Width(), x, y, w, h, 0x0, BOWL_DARK);
	SD_Rct(backgnd->Surface()->pixels, backgnd->Width(), x, y, w - 1, h - 1, BC_NRML);
	SD_Rct(backgnd->Surface()->pixels, backgnd->Width(), x + 1, y + 1, w - 1, h - 1, BC_DARK);

}

Preview::~Preview()
{
    if (block) delete block;
}

void Preview::IsUnknown(SDLSurface *quest_mark, float *pct)
{
    q_mark = quest_mark;
    q_pct = pct;
    is_unknown = 1;
}

void Preview::Hide()
{
	backgnd->Blit(x, y, sdl->Screen(), x, y, w, h);
}

void Preview::Update(SDL_Rect *rects, int *rect_num)
{
	if (is_unknown) {
		SC_Trp_X(sdl->Screen()->pixels, sdl->Screen()->w, x + (w - q_mark->Width()) / 2, y + (h - q_mark->Height()) / 2, q_mark->Surface()->pixels, q_mark->Width(), 0, 0, q_mark->Width(), q_mark->Height(), (int)*q_pct);
		if (*rect_num < DRAWRECTS)	 {
			SDL_Rect rect = {x, y, w, h};
			rects[(*rect_num)++] = rect;
		}
		return;
	}
	if (!bowl->NewNextBlock()) {
		block->Blit(0, 0, sdl->Screen(), x, y, w, h);
		if (*rect_num < DRAWRECTS)	 {
			SDL_Rect rect = {x, y, w, h};
			rects[(*rect_num)++] = rect;
		}
		return;
	}
	BlockInit	*n = bowl->Next();
	int	l1, l2, i, px, py;
	int x1 = 3, x2 = 0;
	int y1 = 3, y2 = 0;
	for (i = 0; i < 4; i++) {
		l1 = 0;
		while (l1 < 3 && !n->blocks[0][i][l1]) l1++;
		if (l1 < y1) y1 = l1;
		l2 = 3;
		while (l2 > 0 && !n->blocks[0][i][l2]) l2--;
		if (l2 > y2) y2 = l2;
	}
	for (i = 0; i < 4; i++) {
		l1 = 0;
		while (l1 < 3 && !n->blocks[0][l1][i]) l1++;
		if (l1 < x1) x1 = l1;
		l2 = 3;
		while (l2 > 0 && !n->blocks[0][l2][i]) l2--;
		if (l2 > x2) x2 = l2;
	}
	
	backgnd->Blit(x, y, sdl->Screen(), x, y, w, h);
	px = x + ((w - ((x2 - x1) + 1)*BLOCKSIZE) / 2);
	py = y + ((h - ((y2 - y1) + 1)*BLOCKSIZE) / 2);
	for (i = x1; i < 4; i++)	
		for (int j = y1; j < 4; j++)
			if (n->blocks[0][i][j]) {
				if (trp)
					SC_Trp_X(sdl->Screen()->pixels, sdl->Width(), px + (i-x1)*BLOCKSIZE, py + (j-y1)*BLOCKSIZE, blocks->Surface()->pixels, blocks->Width(), n->id*BLOCKSIZE, 0, BLOCKSIZE, BLOCKSIZE, BLOCK_TRP);
				else
					SC_Clp(sdl->Screen()->pixels, sdl->Width(), px + (i-x1)*BLOCKSIZE, py + (j-y1)*BLOCKSIZE, blocks->Surface()->pixels, blocks->Width(), n->id*BLOCKSIZE, 0, BLOCKSIZE, BLOCKSIZE);
			}
	sdl->Blit(x, y, block, 0, 0, w, h);
				
	if (*rect_num < DRAWRECTS)	 {
		SDL_Rect rect = {x, y, w, h};
		rects[(*rect_num)++] = rect;
	}
}
