/***************************************************************************
                          sdlfont.h  -  description
                             -------------------
    begin                : Mon Feb 28 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SDLFONT_H
#define SDLFONT_H

#include "sdlsurface.h"
#include "gfx.h"

/**
  *@author Michael Speck
  */

#define TA_X_LEFT	(1L<<1)
#define TA_X_CENTER	(1L<<2)
#define TA_X_RIGHT	(1L<<3)
#define TA_Y_TOP	(1L<<4)
#define TA_Y_CENTER	(1L<<5)
#define TA_Y_BOTTOM	(1L<<6)
class SDLFont {
public: 
	SDLFont(char *f);
	SDLFont(char *f, int off, int len, int w);
	~SDLFont();
	int Write(SDL_Surface *dest, int x, int y, char *str, int trp = 100);
	int Write(SDL_Surface *dest, int x, int y, char *str, int clr, int pct);
	void SetAlignment(int a);
	void SetColor(int c);
	int  Color();
	void Begin();
	void End();
	int	LastX();
	int	LastY();
	int	LastW();
	int	LastH();
	SDL_Rect LastRect();
	int TextWidth(char *str);
	int Height();
	
private:
	SDLSurface	*data;
	int			algn;
	int			color;
	int			lh;
	char		lw[256];
	int			l_offset[256];
	char		keys[256]; //allowed keys
	char		offset;
	char		length;
	
	//last writing rect
	int			lastX;
	int			lastY;
	int			lastW;
	int			lastH;
};

#endif
