/***************************************************************************
                          wave.cpp  -  description
                             -------------------
    begin                : Mon Mar 13 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <string.h>
#include "wave.h"
#include "defs.h"

Wave::Wave(char *filename)
{
	buffer = 0;
	length = 0;
	if (SDL_LoadWAV(filename, &spec, &buffer, &length) == 0) {
    	char path[strlen(src_dir)+ strlen(filename) + 1];
	    sprintf(path, "%s%s", src_dir, filename);
    	if (SDL_LoadWAV(path, &spec, &buffer, &length) == 0) {
		    printf("sndsrv: ERROR: loadwave: %s\n", SDL_GetError());
		    exit(1);
		}
	}
	spec.callback = 0;
	spec.userdata = 0;
}

Wave::~Wave()
{
	if (buffer) SDL_FreeWAV(buffer);
}

SDL_AudioSpec Wave::Spec()
{
	return spec;
}

unsigned char* Wave::Buffer()
{
	return buffer;
}

unsigned int Wave::Length()
{
	return length;
}

void Wave::Format(SDL_AudioSpec dest)
{
	if (dest.channels != spec.channels || dest.format != spec.format || dest.samples != spec.samples) {
		SDL_AudioCVT	cvt;
		SDL_BuildAudioCVT(&cvt, spec.format, spec.channels, spec.samples, dest.format, dest.channels, dest.samples);
		cvt.len = length;
		if (cvt.len_mult > 1) {
			unsigned char *new_buf = new unsigned char[cvt.len * cvt.len_mult];
			memcpy(new_buf, buffer, cvt.len * cvt.len_mult);
			delete buffer;
			buffer = new_buf;
		}
		cvt.buf = buffer;
	}
}
